Attribute VB_Name = "StringFilter"
Public Const cLetters = "abcdefghijklmnopqrstuvwxyz"
Public Const cNumbers = "0123456789"
Public Const cWhiteSpaces = " " & vbCr & vbLf & vbTab

Public Function Filter( _
    ByVal Text As String, _
    ByVal Chars As String, _
    Optional ByVal PassThru As Boolean = False, _
    Optional ByVal Compare As VbCompareMethod = vbTextCompare _
    ) As String
  Dim i As Long
  
  If PassThru Then
    'Nur angegebene Zeichen durchlassen:
    For i = 1 To Len(Text)
      If InStr(1, Chars, Mid$(Text, i, 1), Compare) Then
        Filter = Filter & Mid$(Text, i, 1)
      End If
    Next i
  Else
    'Angegebene Zeichen entfernen:
    For i = 1 To Len(Text)
      If InStr(1, Chars, Mid$(Text, i, 1), Compare) = 0 Then
        Filter = Filter & Mid$(Text, i, 1)
      End If
    Next i
  End If
End Function

